﻿# 2020/04/30: TiffToWebPanim.ps1 1.0 converts frames *.tiff to .webp animation using Google img2webp
Set-StrictMode -Version 2.0 # Powershell open source without any warranty powered by echiquierBriochin.fr
# http://echiquierbriochin.fr/webp-gif-le-jpeg/
$project = "ZeMarmot"; $loop = "0";    $zip = "6"; $quality = "0.8"; $TimeExpected = "15s"; $mode = "lossy"   # 1001 x 768 pixels
#$project= "immortal"; $loop = "1001"; $zip = "6"; $quality = "1";   $TimeExpected =  "2s"; $mode = "lossless" # 244 x 246
$result = "$project.webp"
$dirIn = "C:\Users\Chess\Pictures\webp\$project"
$PathFrames = Join-Path -Path $dirIn -ChildPath "tiff\*.tiff" # Frames in TIFF format
$FileInTime = Join-Path -Path $dirIn -ChildPath "frameDuration.txt"
$tool = "C:\Tool\WebP\libwebp-1.1.0-windows-x64\bin\img2webp.exe" # Google WebB SDK
$fileOut = "fileOut.txt" # standard output of img2webp.exe

#region aguments of img2webp
[System.Collections.ArrayList]$lstLine = @()
$eat = $lstLine.Add("-v -loop $loop") # (v)erbose mode then number of loop: 0 means infinite loop
if (!(Test-Path -Path $FileInTime)) {Write-Error "Cannot find $FileInTime" -ErrorAction Stop}
$durations = Get-Content -Path $FileInTime # generated by TinyScheme in Gimp 2.10.18
$idxFrame = 0
dir $PathFrames | foreach { $frameDuration = $durations[$idxFrame++]
    $eat = $lstLine.Add("-$mode -m $zip -q $quality -d $frameDuration $_")
} #                                                     ^ in ms        ^.tiff
$eat = $lstLine.Add("-o $result") # generated (o)utput .WebP animation
$img2webpArgs = ""; $lstLine | ForEach {$img2webpArgs = $img2webpArgs + $_ + " "} # array to string
$img2webpArgs = $img2webpArgs.Trim() # Remove the trailing space of the last  ^ option
#endregion aguments of img2webp

#region main
$isDebug = $false # $true
if ($isDebug) { Write-Host($img2webpArgs)} # Show the full argument of img2webp.exe
else
{   cd $dirIn
    Write-Verbose -Message "Processing frames during about $TimeExpected in progress..." -Verbose
    (Measure-Command {Start-Process -FilePath $tool -ArgumentList $img2webpArgs -NoNewWindow -RedirectStandardError $fileOut -Wait}) -f "Time HH:MM:SS"
    Get-Content $fileOut -Head 3 # Display the first three lines of the standard output redirected from standard error
    Write-Host "..."             # Skip intermediate frames
    Get-Content $fileOut -Tail 3 # Display the last three lines
    dir $result | Format-Table -Property Name, Length, LastWriteTime, Directory
}
#endregion main
